using System;

namespace HaskellRTS
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class Closure
	{   public bool evaluated = false;
        public object value;

        public delegate object eval_delegate ();
		//public eval_delegate eval_fn () {return null;}
        public eval_delegate eval_fn;

		public Closure () 
		{
			value = this;
			evaluated = true;
			eval_fn = new eval_delegate(returnthis);
		}

		// initialization with a WHNF value
		public Closure (object initial_value)
		{   
			value = initial_value;
            evaluated = true;
			eval_fn = new eval_delegate(returnvalue);
		}

		// unevaluated closure. Do we need the first parameter?
		public Closure (eval_delegate clos) 
		{
			value = null;
			// this works:
			//eval_delegate tmp = new eval_delegate(clos);
			eval_fn = clos;
		}

		public object eval () 
		{
			value = eval_fn();
			evaluated = true;
			eval_fn = new eval_delegate(returnvalue);
			return value;
			// maybe: change to return null/void
		}

		public object returnvalue ()
		{ return value; }

		public object returnnull ()
		{ return null; }

		public object returnthis ()
		{ return this; }


	}
}
